#ifndef __CTISLIST_H
#define __CTISLIST_H

class CTISList {
public:
	CTISList(CTISList *nxt=NULL);
	~CTISList();

	islist*			GetList() { return mList; }

	CTISList*		GetNext() { return mNextCTISList;	}
	void __inline	SetNext(CTISList* nxt) { mNextCTISList = nxt; }

	/* Resets the counts of all ItemSets in the list to 0 */
	void			ResetCounts();
	/* Resets the counts in the list to 0 from 'start' up till, but -not- including 'stop' */
	void			ResetCounts(islist::iterator start, islist::iterator stop);

	/* Backs up current count of all ItemSets in the list */
	void			BackupCounts();
	/* Backs up current count of ItemSets in the list from 'start' up till, but -not- including 'stop' */
	void			BackupCounts(islist::iterator start, islist::iterator stop);

	/* Rolls back counts of all ItemSets in the list to previousCount */
	void			RollbackCounts();
	/* Rolls back counts of ItemSets in the list to previousCount from 'start' up till, but -not- including 'stop' */
	void			RollbackCounts(islist::iterator start, islist::iterator stop);

	uint32			RemoveZeroCountCodes();

	void			BuildItemSetList(islist *ilist);
	void			BuildPrePruneList(islist *ilist);
	void			BuildPostPruneList(islist *pruneList, const islist::iterator &after);
	void			BuildSanitizePruneList(islist *ilist);

protected:
	CTISList *mNextCTISList;
	islist	 *mList;
};

#endif // __CTISLIST_H
