#ifndef __DOUBLEDATABASE_H
#define __DOUBLEDATABASE_H

#include "Database.h"

class BASS_API DoubleDatabase : public Database {
public:
	DoubleDatabase();
	DoubleDatabase(Database *dbLeft, Database *dbRight); // takes ownership of both provided databases
	DoubleDatabase(DoubleDatabase *ddb);
	virtual ~DoubleDatabase();
	virtual DoubleDatabase*	Clone();

	Database*	GetLeftDatabase()			{ return mDbLeft; }
	Database*	GetRightDatabase()			{ return mDbRight; }
	ItemSet**	GetLeftRows()				{ return mRowsLeft; }
	ItemSet**	GetRightRows()				{ return mRowsRight; }
	ItemSet*	GetLeftRow(const uint32 r)	{ return mRowsLeft[r]; }
	ItemSet*	GetRightRow(const uint32 r)	{ return mRowsRight[r]; }

	uint32		GetAlphabetSplit()			{ return mAlphSplit; }

protected:
	Database	*mDbLeft, *mDbRight;
	ItemSet		**mRowsLeft, **mRowsRight;
	uint32		mAlphSplit;
};

#endif // __DOUBLEDATABASE_H
