#ifndef __EXACTSEARCH_H
#define __EXACTSEARCH_H

class Uint16ItemSet;
class Pair;

#include "RemodelSearch.h"

// Iterative exact top-1 search
class ExactSearch : public RemodelSearch {
public:
	ExactSearch(Config *config);
	virtual ~ExactSearch();

	/* ---- Basic get/set ---- */

	/* ---- Perform search ---- */
	virtual void				Init(DoubleDatabase *ddb);
	virtual TranslationTable*	MineThatTable();

protected:
	// Settings
	uint64			mMaxPasses;
	uint32			mMinSup;

	// Members
	Database*		mVerticalDb;
	Uint16ItemSet**	mItems;
	uint16*			mAlph2Item;
	uint16*			mItem2Alph;
	Pair**			mPairs;
	uint32			mNumPairs;
	char*            mNameDB;
};

#endif // __EXACTSEARCH_H
