#ifndef __RULENODE_H
#define __RULENODE_H

class Pair;
class RuleTree;
class TranslationRule;
class TranslationTable;

class RuleNode {
public:
	RuleNode(RuleTree *tree, const uint32 addPairIdx);
	RuleNode(RuleTree *tree, const bool addToLeft, const uint16 addItem, const uint16 resumeItem, RuleNode *parent, Uint16ItemSet *leftTidSet, Uint16ItemSet *rightTidSet, const float changedPotential);
	~RuleNode();

	void MineBestRule(TranslationRule **bestRule, float &bestGain, const bool expandLeft = true);
	
protected:
	// Members owned by RuleNode
	ItemSet				*mLeftSet;
	ItemSet				*mRightSet;

	uint32				mExpandFromLeft;
	uint32				mExpandFromRight;

	float				mLeftStdSize;
	float				mRightStdSize;

	float				mToLeftPotential;
	float				mToRightPotential;

	// Members not owned by RuleNode
	RuleTree			*mTree;
	Uint16ItemSet		*mLeftTidSet;
	Uint16ItemSet		*mRightTidSet;
};

#endif // __RULENODE_H
