#include "../global.h"

#include <logger/Log.h>

#include "CandidateRule.h"
CandidateRule::CandidateRule(ItemSet *setL, const RuleDirection dir, ItemSet *setR, double gain, uint64 pos) {
	mLeftSet = setL;
	mDirection = dir;
	mRightSet = setR;
	mGain = gain;
	mPos = pos;

}
CandidateRule::CandidateRule(const CandidateRule &cr) {
	mLeftSet = cr.mLeftSet->Clone();
	mDirection = cr.mDirection;
	mRightSet = cr.mRightSet->Clone();
	mGain = cr.mGain;
	mPos = cr.mPos;
}

CandidateRule::~CandidateRule() {
	delete mLeftSet;
	delete mRightSet;
	
}
CandidateRule* CandidateRule::Clone() {
	return new CandidateRule(*this);
}

void CandidateRule::SetDirection(const RuleDirection dir) {
	 mDirection = dir;
}

void CandidateRule::SetGain(double gain) {
	 mGain = gain;
}

string CandidateRule::ToString() {
	string s = mLeftSet->ToString(false, false);
	if(!mLeftSet->IsEmpty()) s += " ";
	s += mDirection==RuleBoth ? "<->" : (mDirection==RuleToRight ? "->" : "<-");
	if(!mRightSet->IsEmpty()) s += " ";
	s += mRightSet->ToString(false, false);
	return s;
}
