#ifndef __CANDIDATERULE_H
#define __CANDIDATERULE_H

class ItemSet;
class ItemSetCollection;

#include <Bass.h>
#include <itemstructs/ItemSet.h>
#include "../translate/TranslationRule.h"

class CandidateRule;
typedef std::list<CandidateRule*> candlist;

class CandidateRule {
public:
	CandidateRule(ItemSet *setL, const RuleDirection dir, ItemSet *setR, double gain, uint64 pos);
	CandidateRule(const CandidateRule &cr);
	virtual ~CandidateRule();
	virtual CandidateRule* Clone();

	// Get/set
	ItemSet*		GetLeft()			{ return mLeftSet; }
	ItemSet*		GetRight()			{ return mRightSet; }
	RuleDirection	GetDirection()		{ return mDirection; }
	void			SetDirection(const RuleDirection dir);
	void			SetGain(double gain);
	double			GetGain()	{ return mGain; }
	uint64			GetPos()	{ return mPos; }

	// Serialization
	string			ToString();

protected:

	// Members
	ItemSet*		mLeftSet;
	RuleDirection	mDirection;
	ItemSet*		mRightSet;

	double			mGain;
	uint64			mPos;
};

#endif // __CANDIDATERULE_H
